/*****************************************************************************
 * Bison/Flexプログラム部分をテストするための、Windowsアプリケーションの雛型 *
 * □ビルド・実行方法:                                                       *
 * ┃"C:\Program Files (x86)\Microsoft Visual Studio\VC98\Bin\VCVARS32.BAT"  *
 * ┃make -f winapp.mk run                                                   *
 *****************************************************************************/
#include "winapp.h"
/*---------------------------------------------------------------------------*/
#define Label_Max     50000		/* ラベル登録最大数 */	//調整可
#define CmdByte_Max 1000000		/* 命令バイト最大数 */	//調整可
static uint8_t TBL_CmdByte[CmdByte_Max];	/* 命令バイト配列 */
static int nCmdByte;				/* 命令バイト配列の格納数 */
static char* TBL_Label[Label_Max];		/* ラベル配列 */
static int nLabel;				/* ラベル配列の格納数 */
/*---------------------------------------------------------------------------*/
//エラーログ用
static char err_path[_MAX_PATH];	//'-e'オプションが指定されたら、エラーログファイル名を格納する。
static FILE* fp_err;			//最初のエラーログを記録する時に、エラーログファイルを作成する。
void yyerror(const char* fmt, ...) {	//←{{2015/03/06:'-e'オプション対応のためにwinapp.cから移動しました。}}
	//'-e'オプションが指定されていて、最初のエラーログを記録する時ならば…
	if(*err_path && !fp_err) {
		//エラーログファイルを作成する。
		fp_err = fopen(err_path, "w");
		if(!fp_err) { die("%s が作成できません。\n", err_path); }
		//エラーログファイルの出力ストリームは、バッファリング無しとする。
		// - die()で終了した時(abort()時)に、バッファ分がフラッシュされないようなので、こうしておく必要が有る。
		//   別の案として、この下の処理で毎回fflush()する方法も有るが、バッファリング無しとする方が簡単だろう。
		setbuf(fp_err, NULL);
	}
	//エラーメッセージ(,及び,エラーログ)を出力する。
	             fprintf(stderr, "### error at line %d : ", yylineno);	//エラーメッセージ
	if(fp_err) { fprintf(fp_err, "### error at line %d : ", yylineno); }	//エラーログ
	{
		va_list ap;
		va_start(ap, fmt);
		             vfprintf(stderr, fmt, ap);		//エラーメッセージ
		if(fp_err) { vfprintf(fp_err, fmt, ap); }	//エラーログ
		va_end(ap);
	}
	             fputc('\n', stderr);	//エラーメッセージ
	if(fp_err) { fputc('\n', fp_err); }	//エラーログ
}
/*---------------------------------------------------------------------------*/
/* ローカル関数宣言 */
__declspec(noreturn) static void usage();
static uint8_t* add_cmd_byte(int n);
static void pass2(int bOptimize);
static void optimize();
static void output(char* sPrefix, char* sBinOut);
/*---------------------------------------------------------------------------*/
int main(int argc, char* argv[]) {
	int opt, bOptimize = 1;	//'-d'オプションが指定されなければ最適化を行う。
	char* sPrefix = "";	//'-p'オプションが指定されたらプレフィクス文字列を設定する。
	char* sBinOut = NULL;	//'-o'オプションが指定されたらバイナリ出力ファイル名を設定する。
#if     (YYDEBUG!=0)
//	yydebug = 1; /* nonzero means print parse trace */
#endif/*(YYDEBUG!=0)*/
	/* コマンドラインオプションを処理する。 */
	opterr = 0; /* オプションエラーは当プログラム内で処理するので、getopt()内でのエラー表示は不要。 */
	while((opt = getopt(argc, argv, "dp:o:eh")) != -1) {
		switch(opt) {
		case 'd':
			bOptimize = 0;		//最適化を行わない。
			break;
		case 'p':
			sPrefix = optarg;	//プレフィクス文字列を設定する。
			break;
		case 'o':
			sBinOut = optarg;	//バイナリ出力ファイル名を設定する。
			break;
		case 'e':
			{
				//エラーログファイル名を作成する。
				// - カレントフォルダに'実行ファイル名.err'という名前で生成する事にした。この動作は、'lk33.exe'の仕様を参考にした。
				char fname[_MAX_FNAME];
				_splitpath(argv[0], NULL, NULL, fname, NULL);
				_makepath(err_path, NULL, NULL, fname, ".err");
				//'-e'オプションが指定されたら、最初に確実に、既存のエラーログファイルを削除しておく。
				//前回に生成したエラーログが残っていて、今回生成したエラーログと混同する危険を避けるためである。
				//尚、'-e'オプションが指定されなかった場合は、既存のエラーログファイルを削除する処理は行わない。
				remove(err_path);
			}
			break;
		case 'h':
		default:
			usage();
		}
	}
	/* ラベルを登録するためのハッシュテーブルを作成する。 */
	hcreate(Label_Max);
	/* 判り易さのために、命令位置0は使用しないことにした。命令位置0には、ダミーのend命令を置くことにした。 */
	inst_end();
	//--- 1パス目の処理 ---
	/* ファイルが指定されていなければ、標準入力から読み込む。 */
	if(optind == argc) {
		yylex_init(stdin);
	    //{{2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
	    //	if((yyparse() != 0) || (yynerrs != 0)) { die("エラーが発生しました。\n"); }
	    //↓2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
		if((yyparse() != 0) /*|| (yynerrs != 0)*/) { die("エラーが発生しました。\n"); }
	    //}}2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
	/* ファイルが指定されていたら、各ファイルを読み込む。 */
	} else {
		int i;
		for(i = optind; i < argc; i++) {
			FILE* fp = fopen(argv[i], "r");
			if(!fp) { die("%s が開けません。\n", argv[i]); }
			yylex_init(fp);
		    //{{2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
		    //	if((yyparse() != 0) || (yynerrs != 0)) { die("%s: エラーが発生しました。\n", argv[i]); }
		    //↓2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
			if((yyparse() != 0) /*|| (yynerrs != 0)*/) { die("%s: エラーが発生しました。\n", argv[i]); }
		    //}}2015/02/24修正:致命的なエラーが発生した場合(yyparse()!=0)のみ中断する。セマンティクスエラー(yynerrs!=0)だけならば全てのセマンティクスエラーを報告するために継続する。
			fclose(fp);
		}
	}
	//1パス目の処理でエラーが発生しても、2パス目の処理を行って、全てのセマンティクスエラーを報告する。
	//--- 2パス目の処理 ---
	pass2(bOptimize);
	if(yynerrs != 0) { die("エラーが発生しました。\n"); }	//1パス目,又は,2パス目の処理でエラーが発生していたら、出力処理を行わない。
	//--- 出力処理 ---
	/* 命令バイトを出力する。 */
	output(sPrefix, sBinOut);
	if(yynerrs != 0) { die("エラーが発生しました。\n"); }
	return EXIT_SUCCESS;
}
/*---------------------------------------------------------------------------*/
/* 使い方を表示して終了する。 */
__declspec(noreturn) static void usage() {
	fprintf(stderr, "dSndSeqC - サウンドシーケンサコンパイラ (%s)\n", VERSION);
	fprintf(stderr, "Copyright (C) 2015 Naoyuki Sawa\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "USAGE:\n");
	fprintf(stderr, "  dSndSeqC [option ...] [filename ...] \n");
	fprintf(stderr, "  ・filenameを指定しなければ、標準入力から読み込みます。\n");
	fprintf(stderr, "  ・filenameは、ワイルドカードによる複数指定も可能です。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "OPTIONS:\n");
	fprintf(stderr, "  -d           最適化を行いません。\n");
	fprintf(stderr, "               このオプションを指定しなければ、最適化を行います。\n");
	fprintf(stderr, "  -p文字列     ラベルに、プレフィクス文字列を追加します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、プレフィクス文字列を追加しません。\n");
	fprintf(stderr, "  -oファイル名 サウンド制御のバイナリデータを、バイナリ形式でファイルへ出力します。\n");
	fprintf(stderr, "               このオプションを指定しなければ、Cソース形式で標準出力へ出力します。\n");
	fprintf(stderr, "               このオプションの指定に関らず、ラベルは常に標準出力へ出力します。\n");
	fprintf(stderr, "  -e           エラーログファイルを生成します。\n");
	fprintf(stderr, "               このオプションを指定しても、エラーが発生しなければ生成されません。\n");
	fprintf(stderr, "  -h           使い方を表示します。\n");
	fprintf(stderr, "\n");
	fprintf(stderr, "EXAMPLE:\n");
	fprintf(stderr, "  ①dSndSeqC.exe -pSndSeqNo_ SndDef.txt > SndDef.c\n");
	fprintf(stderr, "  　SndDef.txtをコンパイルして、SndDef.cへ出力します。\n");
	fprintf(stderr, "  　ラベルのプレフィクス文字列として、SndSeqNo_を追加します。\n");
	fprintf(stderr, "  ②dSndSeqC.exe -pSndSeqNo_ -oSndDef.bin SndDef.txt > SndDef.h\n");
	fprintf(stderr, "  　SndDef.txtをコンパイルして、ラベルをSndDef.hへ出力します。\n");
	fprintf(stderr, "  　サウンド制御のバイナリデータを、SndDef.binへ出力します。\n");
	exit(EXIT_FAILURE);
}
/*---------------------------------------------------------------------------*/
static uint8_t* add_cmd_byte(int n) {
	uint8_t* p;
	if((unsigned)(nCmdByte + n) > CmdByte_Max) {
		yyerror("命令バイト数が制限を超えました。(%d)", CmdByte_Max);
		exit(EXIT_FAILURE);
	}
	p = &TBL_CmdByte[nCmdByte];
	nCmdByte += n;
	return p;
}
void inst_def(char* lab) {
	ENTRY item;
	item.key = (char*)lab;
	if(hsearch(item, FIND)) {
		yyerror("defのラベル定義が重複しています。(%s)", lab);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	item.data = (void*)nCmdByte;
	if(!hsearch(item, ENTER)) {
		yyerror("ラベル数が制限を超えました。(%d)", Label_Max);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	if(nLabel < Label_Max) {
		TBL_Label[nLabel++] = lab;	//hsearch()はイテレーションの機能が無いので、後でイテレートするためにはキー配列を別に作成しておく必要が有る。
	}
}
void inst_end() {
	uint8_t* p;
	p = add_cmd_byte(1);
	p[0] = 0x00;	//End
}
void inst_wait(int ms) {
	uint8_t* p;
	       if((ms >= 0x00001) && (ms <= (0x00001 + 0x000000FF))) {
		   ms -= 0x00001;
		p = add_cmd_byte(2);
		p[0] = 0x01;	//Wait1
		p[1] = ms;
	} else if((ms >= 0x00101) && (ms <= (0x00101 + 0x0000FFFF))) {
		   ms -= 0x00101;
		p = add_cmd_byte(3);
		p[0] = 0x02;	//Wait2
		p[1] = ms;
		p[2] = ms >>  8;
	} else if((ms >= 0x10101) && (ms <= (0x10101 + 0x00FFFFFF))) {
		   ms -= 0x10101;
		p = add_cmd_byte(4);
		p[0] = 0x03;	//Wait3
		p[1] = ms;
		p[2] = ms >>  8;
		p[3] = ms >> 16;
	} else {
		p = add_cmd_byte(5);
		p[0] = 0x04;	//Wait4
		p[1] = ms;
		p[2] = ms >>  8;
		p[3] = ms >> 16;
		p[4] = ms >> 24;
	}
}
void inst_stop(int trk) {
	uint8_t* p;
	if((unsigned)trk > SndTrk_Max) {
		yyerror("stopの引数trkが範囲外です。(%d)", trk);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	p = add_cmd_byte(2);
	p[0] = 0x10;	//Stop
	p[1] = trk;
}
void inst_play_m(int trk, int phr, int vol, int pan) {
	uint8_t* p;
	if((unsigned)trk > SndTrk_Max) {
		yyerror("playの引数trkが範囲外です。(%d)", trk);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	if((unsigned)phr > SndPhr_Max) {
		yyerror("playの引数phrが範囲外です。(%d)", phr);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	if((unsigned)vol > SndVol_Max) {
		yyerror("playの引数volが範囲外です。(%d)", vol);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	if((unsigned)pan > SndPan_Max) {
		yyerror("playの引数panが範囲外です。(%d)", pan);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	p = add_cmd_byte(6);
	p[0] = 0x11;	//PlayM
	p[1] = trk;
	p[2] = phr;
	p[3] = phr >> 8;
	p[4] = vol;
	p[5] = pan;
}
void inst_play_s(int trk, int phr, int vol) {
	uint8_t* p;
	if((unsigned)trk > SndTrk_Max) {
		yyerror("playの引数trkが範囲外です。(%d)", trk);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	if((unsigned)phr > SndPhr_Max) {
		yyerror("playの引数phrが範囲外です。(%d)", phr);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	if((unsigned)vol > SndVol_Max) {
		yyerror("playの引数volが範囲外です。(%d)", vol);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	p = add_cmd_byte(5);
	p[0] = 0x12;	//PlayS
	p[1] = trk;
	p[2] = phr;
	p[3] = phr >> 8;
	p[4] = vol;
}
void inst_vol(int trk, int vol) {
	uint8_t* p;
	if((unsigned)trk > SndTrk_Max) {
		yyerror("volの引数trkが範囲外です。(%d)", trk);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	if((unsigned)vol > SndVol_Max) {
		yyerror("volの引数volが範囲外です。(%d)", vol);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	p = add_cmd_byte(3);
	p[0] = 0x20;	//Vol
	p[1] = trk;
	p[2] = vol;
}
void inst_pan(int trk, int pan) {
	uint8_t* p;
	if((unsigned)trk > SndTrk_Max) {
		yyerror("panの引数trkが範囲外です。(%d)", trk);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	if((unsigned)pan > SndPan_Max) {
		yyerror("panの引数panが範囲外です。(%d)", pan);
		yynerrs++;	/* 呼び出し元(main)に知らせるために */
		/* 全てのセマンティクスエラーを報告するために継続する */
	}
	p = add_cmd_byte(3);
	p[0] = 0x21;	//Pan
	p[1] = trk;
	p[2] = pan;
}
/*---------------------------------------------------------------------------*/
//2パス目の処理
static void pass2(int bOptimize) {
	//2015/02/24現在、2パス目の処理は有りません。
	//今後、最適化機能を追加する場合のためのプレースホルダとして、関数のみ用意して有ります。
	//現在のところは、コマンドラインオプションに'-d'を指定してもしなくても違いは有りません。
	if(bOptimize) { optimize(); }
}
static void optimize() {
	//2015/02/24現在、最適化処理は有りません。
	//今後、最適化機能を追加する場合のためのプレースホルダとして、関数のみ用意して有ります。
	//現在のところは、コマンドラインオプションに'-d'を指定してもしなくても違いは有りません。
}
/*---------------------------------------------------------------------------*/
//出力処理
static int Label_compar(const void* x, const void* y) {
	return strcmp(*(char**)x, *(char**)y);
}
static void output(char* sPrefix, char* sBinOut) {
	int iCmdByte, iLabel;
	ENTRY item, *pEntry;
	//ラベル定義を名前の昇順にソートする。
	qsort(TBL_Label, nLabel, sizeof(char*), Label_compar);
	//--- ラベルを標準出力に出力する ---
	for(iLabel = 0; iLabel < nLabel; iLabel++) {				//名前の昇順	ラベル=0(ダミー)は定義しない。
		char* label = TBL_Label[iLabel];
		printf("#define %s%s %d\n", sPrefix, label, iLabel + 1);	//ラベルは1ベース
	}
	if(*sPrefix) { printf("#define %sMax %d\n", sPrefix, nLabel); }		//プレフィクス文字列が有る場合のみ最大値を定義する。(プレフィクス文字列が無ければ定義しない。'Max'という単純なマクロ定義になり問題が有るから。)
	//--- データを出力する ---
	//バイナリ形式の場合…
	if(sBinOut) {
		FILE* fp = fopen(sBinOut, "wb");
		if(!fp) { die("%s が作成できません。\n", sBinOut); }
		//アドレステーブルを出力する。
		for(iLabel = -1; iLabel < nLabel; iLabel++) {
			int addr;
			if(iLabel < 0) {
    //{{2015/03/02変更:TBL_SndSeqNo[0]に(SndSeqNo_Max+1)を格納するようにしました。
    //				addr = 0;					//ラベル番号=0(ダミー)
    //{{2015/03/02変更:TBL_SndSeqNo[0]に(SndSeqNo_Max+1)を格納するようにしました。
				addr = nLabel + 1;				//TBL_SndSeqNo[0]=(SndSeqNo_Max+1)	ラベルは1ベースなのでnLabelではなく(nLabel+1)とする事に注意せよ。
    //{{2015/03/02変更:TBL_SndSeqNo[0]に(SndSeqNo_Max+1)を格納するようにしました。
			} else {
				char* label = TBL_Label[iLabel];
				item.key = label;
				if(!(pEntry = hsearch(item, FIND))) { DIE(); }	//バグ
				addr = (int)pEntry->data;
			}
			fwrite(&addr, sizeof(int), 1, fp);
		}
		//命令コードの出力を行う。
		for(iCmdByte = 0; iCmdByte < nCmdByte; iCmdByte++) {
			int data = TBL_CmdByte[iCmdByte];
			fwrite(&data, sizeof(unsigned char), 1, fp);
		}
		fclose(fp);
	//テキスト形式の場合…
	} else {
		//アドレステーブルを出力する。
		printf("const int TBL_SndSeqNo[%d]={", nLabel + 1);
		for(iLabel = -1; iLabel < nLabel; iLabel++) {
			int addr;
			if(iLabel < 0) {
    //{{2015/03/02変更:TBL_SndSeqNo[0]に(SndSeqNo_Max+1)を格納するようにしました。
    //				addr = 0;					//ラベル番号=0(ダミー)
    //{{2015/03/02変更:TBL_SndSeqNo[0]に(SndSeqNo_Max+1)を格納するようにしました。
				addr = nLabel + 1;				//TBL_SndSeqNo[0]=(SndSeqNo_Max+1)	ラベルは1ベースなのでnLabelではなく(nLabel+1)とする事に注意せよ。
    //{{2015/03/02変更:TBL_SndSeqNo[0]に(SndSeqNo_Max+1)を格納するようにしました。
			} else {
				char* label = TBL_Label[iLabel];
				item.key = label;
				if(!(pEntry = hsearch(item, FIND))) { DIE(); }	//バグ
				addr = (int)pEntry->data;
			}
			if((iLabel & 15) == 15)    { putchar('\n'); }
			printf("0x%08X", addr);
			if(iLabel != (nLabel - 1)) { putchar(',' ); }
		}
		puts("};");
		//命令コードの出力を行う。
		printf("const unsigned char TBL_SndSeq[%d]={", nCmdByte);
		for(iCmdByte = 0; iCmdByte < nCmdByte; iCmdByte++) {
			int data = TBL_CmdByte[iCmdByte];
			if(  iCmdByte      ) { putchar(',' ); }
			if(!(iCmdByte & 31)) { putchar('\n'); }
			printf("0x%02X", data);
		}
		puts("};");
	}
}
